<?php
error_reporting(0);
define('BASEPATH', true);

ini_set('default_charset', 'UTF-8');

if (function_exists('mb_internal_encoding'))
{
  mb_internal_encoding('UTF-8');
}

$root_path = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
@include $root_path . '/storage/configuration/user_setup.php';
require $root_path . '/app/koken/Shutter/Shutter.php';

if (!defined('LOOPBACK_HOST_HEADER'))
{
  define('LOOPBACK_HOST_HEADER', false);
}

Shutter::enable();

$is_ssl = isset($_SERVER['HTTPS']) ? $_SERVER['HTTPS'] === 'on' || $_SERVER['HTTPS'] === 1 : $_SERVER['SERVER_PORT'] == 443;
$protocol = $is_ssl ? 'https' : 'http';
$real_base_folder = preg_replace('~/storage/plugins/.*/rate\.php(.*)?$~', '', $_SERVER['SCRIPT_NAME']);

require($root_path . '/app/site/Koken.php');

Koken::start();
Koken::$protocol = $protocol;
Koken::$location = array(
  'real_root_folder' => $real_base_folder,
);

$read_token = Shutter::get_encryption_key();

$cid = (int) $_POST['cid'];
$rating = (float) $_POST['rating'];
$increment = true;

if (!empty($cid) && !empty($rating))
{
  if (session_id() == '')
  {
    session_start();
  }

  if (isset($_SESSION['ratings']) && is_array($_SESSION['ratings']))
  {
    if (!isset($_SESSION['ratings'][$cid]))
    {
      $_SESSION['ratings'][$cid] = $rating;
    } else {
      $increment = false;
      $rating = $_SESSION['ratings'][$cid];
      unset($_SESSION['ratings'][$cid]);
    }
  }
  else {
    $_SESSION['ratings'] = array(
      $cid => $rating,
    );
  }

  $content = Koken::api('/content/' . $cid . '/token:' . $read_token);

  if (is_array($content) && isset($content['id']))
  {
    $count = isset($content['koken_rating_count']) ? $content['koken_rating_count'] : 0;
    $average = isset($content['koken_rating_average']) ? $content['koken_rating_average'] : 0;

    if ($increment)
    {
      $average = ($average * $count + $rating) / ++$count;
    }
    else
    {
      $count = max(0, --$count);
      $average = $count === 0 ? 0 : ($avg * $count - $rating) / $count;
    }

    $content = Koken::api('/content/' . $cid, 'POST', array('token' => $read_token, 'koken_rating_count' => $count, 'koken_rating_average' => $average, '_method' => 'PUT'));

    if (is_array($content) && isset($content['id']))
    {
      header('Content-Type: application/json', true, 200);
      echo json_encode(array(
        'average' => $average,
        'count' => $count
      ));
    }
  }
}